aboutsummaryrefslogtreecommitdiffstats
path: root/package/base-files/default/sbin/ifup
diff options
context:
space:
mode:
Diffstat (limited to 'package/base-files/default/sbin/ifup')
-rwxr-xr-xpackage/base-files/default/sbin/ifup59
1 files changed, 59 insertions, 0 deletions
diff --git a/package/base-files/default/sbin/ifup b/package/base-files/default/sbin/ifup
new file mode 100755
index 0000000000..3d81364d08
--- /dev/null
+++ b/package/base-files/default/sbin/ifup
@@ -0,0 +1,59 @@
+#!/bin/ash
+[ $# = 0 ] && { echo " $0 <group>"; exit; }
+. /etc/functions.sh
+type=$1
+debug "### ifup $type ###"
+
+if_proto=$(nvram get ${type}_proto)
+if=$(nvram get ${type}_ifname)
+[ "${if%%[0-9]}" = "ppp" ] && if=$(nvram get ${if_proto}_ifname)
+
+if_valid $if || exit
+mac=$(nvram get ${type}_hwaddr)
+$DEBUG ifconfig $if down 2>&-
+
+if [ "${if%%[0-9]}" = "br" ]; then
+ stp=$(nvram get ${type}_stp)
+ $DEBUG brctl delbr $if 2>&-
+ $DEBUG brctl addbr $if
+ $DEBUG brctl setfd $if 0
+ $DEBUG brctl stp $if ${stp:-0}
+
+ for sif in $(nvram get ${type}_ifnames); do
+ if_valid $sif || continue
+ ${mac:+$DEBUG ifconfig $sif down hw ether $mac}
+ $DEBUG ifconfig $sif 0.0.0.0 up
+ $DEBUG brctl addif $if $sif
+ done
+else
+ ${mac:+$DEBUG ifconfig $if down hw ether $mac}
+fi
+
+case "$if_proto" in
+ static)
+ ip=$(nvram get ${type}_ipaddr)
+ netmask=$(nvram get ${type}_netmask)
+ gateway=$(nvram get ${type}_gateway)
+
+ $DEBUG ifconfig $if $ip ${netmask:+netmask $netmask} broadcast + up
+ ${gateway:+$DEBUG route add default gw $gateway}
+
+ [ -f /etc/resolv.conf ] && return
+
+ debug "# --- creating /etc/resolv.conf ---"
+ for dns in $(nvram get ${type}_dns); do
+ echo "nameserver $dns" >> /etc/resolv.conf
+ done
+ ;;
+ dhcp)
+ ip=$(nvram get ${type}_ipaddr)
+ [ -f $pidfile ] && $DEBUG kill $(cat $pidfile)
+ ${DEBUG:-eval} "udhcpc -R -i $if ${ip:+-r $ip} -b -p $pidfile &"
+ ;;
+ none|"")
+ ;;
+ *)
+ [ -x "/sbin/ifup.${if_proto}" ] && { $DEBUG /sbin/ifup.${if_proto} $*; exit; }
+ echo "### ifup $type: ignored ${type}_proto=\"$if_proto\" (not supported)"
+ ;;
+esac